/* TEMPLATE GENERATED TESTCASE FILE
Filename: CWE170_Improper_Null_Termination__char_loop_15.c
Label Definition File: CWE170_Improper_Null_Termination.label.xml
Template File: point-flaw-15.tmpl.c
*/
/*
 * @description
 * CWE: 170 Improper Null Termination
 * Sinks: loop
 *    GoodSink: Copy a string using a loop with explicit null termination
 *    BadSink : Copy a string using a loop without explicit null termination
 * Flow Variant: 15 Control flow: switch(6)
 *
 * @status Reviewed
 *
 * @history

2010-08-23 XXXXX.XXXXX@XXXXX Reviewed
2010-08-23 XXXXX.XXXXX@XXXXX Added functional variants
2010-08-16 XXXXX.XXXXX@XXXXX Marked as Reviewed
2010-08-13 XXXXX@XXXXX Marked as Ready for Review
2010-08-10 XXXXX@XXXXX changed to a point-flaw; changed status to "In Progress"; updated logic to make src buffer larger than dest
2010-07-22 XXXXX@XXXXX renamed label file
2010-07-21 XXXXX@XXXXX modified to use the CharList entity; moved initialization to BadSource to allow this test case to work for all flow variants; initial review for QC; changed status to "Ready for Review"
2010-06-25 XXXXX@XXXXX consolidate label XMLs
2010-06-22 XXXXX@XXXXX added description to GoodSource
2010-05-24 XXXXX@XXXXX initial version

 */

#include "std_testcase.h"

#include <wchar.h>

#ifndef OMITBAD

void CWE170_Improper_Null_Termination__char_loop_15_bad()
{
    switch(6)
    {
    case 6:
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        /* FLAW: do not explicitly null terminate dest after the loop */
        printLine(dest);
    }
    break;
    default:
        /* INCIDENTAL: CWE 561 Dead Code, the code below will never run */
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        dest[99] = '\0'; /* FIX: null terminate dest */
        printLine(dest);
    }
    }
}

#endif /* OMITBAD */

#ifndef OMITGOOD

/* good1() changes the switch to switch(5) */
static void good1()
{
    switch(5)
    {
    case 6:
        /* INCIDENTAL: CWE 561 Dead Code, the code below will never run */
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        /* FLAW: do not explicitly null terminate dest after the loop */
        printLine(dest);
    }
    break;
    default:
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        dest[99] = '\0'; /* FIX: null terminate dest */
        printLine(dest);
    }
    }
}

/* good2() reverses the blocks in the switch */
static void good2()
{
    switch(6)
    {
    case 6:
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        dest[99] = '\0'; /* FIX: null terminate dest */
        printLine(dest);
    }
    break;
    default:
        /* INCIDENTAL: CWE 561 Dead Code, the code below will never run */
    {
        char src[150], dest[100];
        int i;
        /* Initialize src */
        memset(src, 'A', 149);
        src[149] = '\0';
        for(i=0; i < 100; i++)
        {
            dest[i] = src[i];
        }
        /* FLAW: do not explicitly null terminate dest after the loop */
        printLine(dest);
    }
    }
}

void CWE170_Improper_Null_Termination__char_loop_15_good()
{
    good1();
    good2();
}

#endif /* OMITGOOD */

/* Below is the main(). It is only used when building this testcase on
   its own for testing or for building a binary to use in testing binary
   analysis tools. It is not used when compiling all the testcases as one
   application, which is how source code analysis tools are tested. */

#ifdef INCLUDEMAIN

int main(int argc, char * argv[])
{
    /* seed randomness */
    srand( (unsigned)time(NULL) );
#ifndef OMITGOOD
    printLine("Calling good()...");
    CWE170_Improper_Null_Termination__char_loop_15_good();
    printLine("Finished good()");
#endif /* OMITGOOD */
#ifndef OMITBAD
    printLine("Calling bad()...");
    CWE170_Improper_Null_Termination__char_loop_15_bad();
    printLine("Finished bad()");
#endif /* OMITBAD */
    return 0;
}

#endif
